/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.47 by adcroft, Tue Nov 25 14:57:45 2003 UTC revision 1.112 by edhill, Fri Dec 10 13:07:47 2004 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 62  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    .SUFFIXES:
128    .SUFFIXES: .$tfs .F
129    .F.$tfs:
130            $LN \$< \$@
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                build_cyrus_makedepend
199                RETVAL=$?
200                if test "x$RETVAL" != x0 ; then
201                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
202                fi
203                rm -f ./genmake_cy_md
204            fi
205        else
206            #  echo "MAKEDEPEND=${MAKEDEPEND}"
207            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
208            RETVAL=$?
209            if test x"$RETVAL" = x0 ; then
210                build_cyrus_makedepend
211            fi
212        fi
213    }
214    
215    
216    build_cyrus_makedepend()  {
217        rm -f ./genmake_cy_md
218        (
219            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
220                &&  ./configure > /dev/null 2>&1  \
221                &&  make > /dev/null 2>&1
222            if test -x ./makedepend.exe ; then
223                $LN ./makedepend.exe ./makedepend
224            fi
225            ./makedepend ifparser.c > /dev/null 2>&1  \
226                &&  echo "true"
227        ) > ./genmake_cy_md
228        grep true ./genmake_cy_md > /dev/null 2>&1
229        RETVAL=$?
230        rm -f ./genmake_cy_md
231        if test "x$RETVAL" = x0 ; then
232            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
233            return 0
234        else
235            echo "WARNING: unable to build cyrus-imapd-makedepend"
236            return 1
237        fi
238    }
239    
240  # Guess possible config options for this host  # Guess possible config options for this host
241  find_possible_configs()  {  find_possible_configs()  {
242    
243      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
244      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
245      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
246      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
247        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
248        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
249        PLATFORM=$tmp3
250        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
251      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
252      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
253            
# Line 93  find_possible_configs()  { Line 267  find_possible_configs()  {
267          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
268      fi      fi
269    
270      # makedepend is not always available      look_for_makedepend
271      if test "x${MAKEDEPEND}" = x ; then  
272        which makedepend >& /dev/null      #================================================================
273        RETVAL=$?      #  look for possible C compilers
274        if test "x${RETVAL}" = x1 ; then      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
275           echo "    makedepend was not found. Using xmakedpend instead."      p_CC=
276           MAKEDEPEND='$(TOOLSDIR)/xmakedepend'      for c in $tmp ; do
277        fi          rm -f ./genmake_hello.c  ./genmake_hello
278            cat >> genmake_hello.c << EOF
279    #include <stdio.h>
280    int main(int argc, char **argv) {
281      printf("Hello!\n");
282      return 0;
283    }
284    EOF
285            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
286            RETVAL=$?
287            if test "x${RETVAL}" = x0 ; then
288                p_CC="$p_CC $c"
289            fi
290        done
291        rm -f ./genmake_hello.c ./genmake_hello
292        if test "x${p_CC}" = x ; then
293            cat 1>&2 <<EOF
294    
295    Error: No C compilers were found in your path.  Please specify one using:
296    
297        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
298        2) the CC or MITGCM_CC environment variables.
299    
300    EOF
301            exit 1
302        else
303            echo "  The possible C compilers found in your path are:"
304            echo "   "$p_CC
305            if test "x$CC" = x ; then
306                CC=`echo $p_CC | $AWK '{print $1}'`
307                echo "  Setting C compiler to: "$CC
308            fi
309      fi      fi
310    
311      # look for possible fortran compilers      #================================================================
312        #  look for possible FORTRAN compilers
313      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
314      p_FC=      p_FC=
315      for c in $tmp ; do      for c in $tmp ; do
# Line 129  Error: No Fortran compilers were found i Line 335  Error: No Fortran compilers were found i
335    
336      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
337      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
338      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
339    
340  EOF  EOF
341          exit 1          exit 1
# Line 138  EOF Line 344  EOF
344          echo "   "$p_FC          echo "   "$p_FC
345          if test "x$FC" = x ; then          if test "x$FC" = x ; then
346              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
347                echo "  Setting FORTRAN compiler to: "$FC
348          fi          fi
349      fi      fi
350    
351      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
352          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
353          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
354              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
355              echo "  The options file:  $p_OF"          fi
356              echo "    appears to match so we'll use it."      fi
357              break  #    echo "  The options file:  $p_OF"
358          fi  #    echo "    appears to match so we'll use it."
359      done  #   for i in $p_FC ; do
360    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
361    #if test -r $p_OF ; then
362    #    OPTFILE=$p_OF
363    #    echo "  The options file:  $p_OF"
364    #    echo "    appears to match so we'll use it."
365    #    break
366    #fi
367    #   done
368      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
369          cat 1>&2 <<EOF          cat 1>&2 <<EOF
370    
# Line 208  get_pdepend_list()  { Line 423  get_pdepend_list()  {
423      . ./.pd_tmp      . ./.pd_tmp
424      rm -f ./.pd_tmp      rm -f ./.pd_tmp
425    
426      echo -n "PNAME = "${}      printf "PNAME = "${}
427  }  }
428    
429    
# Line 222  Usage: "$0" [OPTIONS] Line 437  Usage: "$0" [OPTIONS]
437      -help | --help | -h | --h      -help | --help | -h | --h
438            Print this help message and exit.            Print this help message and exit.
439    
440        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
441          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
442              Use "NAME" as the adoptfile.  By default, the file at
443              "tools/adjoint_options/adjoint_default" will be used.
444    
445      -nooptfile | --nooptfile      -nooptfile | --nooptfile
446        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
447        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 246  Usage: "$0" [OPTIONS] Line 466  Usage: "$0" [OPTIONS]
466        --makefile=NAME | -mf=NAME        --makefile=NAME | -mf=NAME
467            Call the makefile "NAME".  The default is "Makefile".            Call the makefile "NAME".  The default is "Makefile".
468    
469        -makedepend NAME | -md NAME
470          --makedepend=NAME | -md=NAME
471              Use "NAME" for the MAKEDEPEND program.
472    
473      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
474        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
475            Specify the location of the MITgcm ROOTDIR as "NAME".            Specify the location of the MITgcm ROOTDIR as "NAME".
# Line 282  Usage: "$0" [OPTIONS] Line 506  Usage: "$0" [OPTIONS]
506            will search for a working compiler by trying a list of            will search for a working compiler by trying a list of
507            "usual suspects" such as g77, f77, etc.            "usual suspects" such as g77, f77, etc.
508    
509        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
510              Use "NAME" as the C compiler.  By default, genmake
511              will search for a working compiler by trying a list of
512              "usual suspects" such as gcc, c89, cc, etc.
513    
514      -[no]ieee | --[no]ieee      -[no]ieee | --[no]ieee
515            Do or don't use IEEE numerics.  Note that this option            Do or don't use IEEE numerics.  Note that this option
516            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
517            is being used.            is being used.
518    
519        -mpi | --mpi
520              Include MPI header files and link to MPI libraries
521        -mpi=PATH | --mpi=PATH
522              Include MPI header files and link to MPI libraries using MPI_ROOT
523              set to PATH. i.e. Include files from \$PATH/include, link to libraries
524              from \$PATH/lib and use binaries from \$PATH/bin.
525    
526        -bash NAME
527              Explicitly specify the Bourne or BASH shell to use
528    
529    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
530    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
531    
# Line 307  EOF Line 546  EOF
546    
547  #  Build a CPP macro to automate calling C routines from FORTRAN  #  Build a CPP macro to automate calling C routines from FORTRAN
548  get_fortran_c_namemangling()  {  get_fortran_c_namemangling()  {
549    
550        #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
551        if test ! "x$FC_NAMEMANGLE" = x ; then
552            return 0
553        fi
554    
555      default_nm="#define FC_NAMEMANGLE(X) X ## _"      default_nm="#define FC_NAMEMANGLE(X) X ## _"
556            
557      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
# Line 324  WARNING: Please contact <MITgcm-support@ Line 569  WARNING: Please contact <MITgcm-support@
569  EOF  EOF
570          return 1          return 1
571      fi      fi
572      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
573      RETVAL=$?      RETVAL=$?
574      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
575          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 354  WARNING: Please contact <MITgcm-support@ Line 599  WARNING: Please contact <MITgcm-support@
599  EOF  EOF
600          return 1          return 1
601      fi      fi
602      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
603      RETVAL=$?      RETVAL=$?
604      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
605          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 430  EOF Line 675  EOF
675  }  }
676    
677    
678    check_HAVE_STAT()  {
679        get_fortran_c_namemangling
680        cat <<EOF > genmake_tc_1.c
681    $FC_NAMEMANGLE
682    #include <stdio.h>
683    #include <stdlib.h>
684    #include <unistd.h>
685    #include <sys/stat.h>
686    #include <sys/types.h>
687    void FC_NAMEMANGLE(tfsize) ( int *nbyte )
688    {
689        char name[512];
690        struct stat astat;
691    
692        name[0] = 'a'; name[1] = '\0';
693        if (! stat(name, &astat))
694            *nbyte = (int)(astat.st_size);
695        else
696            *nbyte = -1;
697    }
698    EOF
699        make genmake_tc_1.o >> genmake_tc.log 2>&1
700        RET_C=$?
701        cat <<EOF > genmake_tc_2.f
702          program hello
703          integer nbyte
704          call tfsize(nbyte)
705          print *," HELLO WORLD", nbyte
706          end program hello
707    EOF
708        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
709        RET_F=$?
710        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
711        RETVAL=$?
712        if test "x$RETVAL" = x0 ; then
713            HAVE_STAT=t
714            DEFINES="$DEFINES -DHAVE_STAT"
715        fi
716        rm -f genmake_tc*
717    }
718    
719    
720    check_netcdf_libs()  {
721        echo "" > genmake_tnc.log
722        cat <<EOF > genmake_tnc.for
723          program fgennc
724    #include "netcdf.inc"
725          integer iret, ncid, xid
726          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
727          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
728          iret = nf_def_dim(ncid, 'X', 11, xid)
729          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
730          iret = nf_close(ncid)
731          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
732          end
733    EOF
734        echo "Executing:" > genmake_tnc.log
735        echo "  $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f" \
736            > genmake_tnc.log
737        RET_CPP=f
738        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
739            &&  RET_CPP=t
740        if test "x$RET_CPP" = xf ; then
741            echo "  WARNING: CPP failed to pre-process the netcdf test." \
742                > genmake_tnc.log
743            echo "    Please check that \$INCLUDES is properly set." \
744                > genmake_tnc.log
745        fi
746        echo "Executing:" > genmake_tnc.log
747        echo "  $FC $FFLAGS $FOPTIM -c genmake_tnc.f" > genmake_tnc.log
748        echo "  $LINK -o genmake_tnc.o $LIBS" > genmake_tnc.log
749        $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
750            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
751        RET_COMPILE=$?
752    
753        #EH3  Remove test program execution for machines that either disallow
754        #EH3  execution or cannot support it (eg. cross-compilers)
755        #EH3
756        #EH3 test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
757        #EH3 RETVAL=$?
758        #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
759    
760        if test "x$RET_COMPILE" = x0 ; then
761            HAVE_NETCDF=t
762        else
763            # try again with "-lnetcdf" added to the libs
764            $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
765                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
766                &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
767            RET_COMPILE=$?
768            if test "x$RET_COMPILE" = x0 ; then
769                LIBS="$LIBS -lnetcdf"
770                HAVE_NETCDF=t
771            else
772                cat genmake_tnc.log >> genmake_warnings
773            fi
774        fi
775        rm -f genmake_tnc*
776    }
777    
778    
779    
780    ###############################################################################
781    #   Sequential part of script starts here
782    ###############################################################################
783    
784  #  Set defaults here  #  Set defaults here
785  COMMANDL="$0 $@"  COMMANDL="$0 $@"
786    
# Line 438  LN= Line 789  LN=
789  S64=  S64=
790  KPP=  KPP=
791  FC=  FC=
792    #CC=gcc
793    CPP=
794  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
795  DEFINES=  DEFINES=
796  PACKAGES=  PACKAGES=
797  ENABLE=  ENABLE=
798  DISABLE=  DISABLE=
799  MAKEFILE=  MAKEFILE=
800  MAKEDEPEND=  #MAKEDEPEND=
801  PDEPEND=  PDEPEND=
802  DUMPSTATE=t  DUMPSTATE=t
803  PDEFAULT=  PDEFAULT=
804  OPTFILE=  OPTFILE=
805  INCLUDES="-I."  INCLUDES="-I. $INCLUDES"
806  FFLAGS=  FFLAGS=
807  FOPTIM=  FOPTIM=
808  CFLAGS=  CFLAGS=
809  KFLAGS1=  KFLAGS1=
810  KFLAGS2=  KFLAGS2=
811    #LDADD=
812  LIBS=  LIBS=
813  KPPFILES=  KPPFILES=
814  NOOPTFILES=  NOOPTFILES=
815  NOOPTFLAGS=  NOOPTFLAGS=
816    MPI=
817    MPIPATH=
818    
819  # DEFINES checked by test compilation  # DEFINES checked by test compilation
820  HAVE_SYSTEM=  HAVE_SYSTEM=
821  HAVE_FDATE=  HAVE_FDATE=
822  FC_NAMEMANGLE=  FC_NAMEMANGLE=
823  HAVE_CLOC=  HAVE_CLOC=
824    HAVE_STAT=
825    HAVE_NETCDF=
826    HAVE_ETIME=
827    
828  MODS=  MODS=
829  TOOLSDIR=  TOOLSDIR=
830  SOURCEDIRS=  SOURCEDIRS=
831  INCLUDEDIRS=  INCLUDEDIRS=
832  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
833    
834    G2ARGS=
835    BASH=
836  PWD=`pwd`  PWD=`pwd`
837  MAKE=make  MAKE=make
838  AWK=awk  AWK=awk
839  THISHOSTNAME=`hostname`  THISHOST=`hostname`
840  THISCWD=`pwd`  THISCWD=`pwd`
841  THISDATE=`date`  THISDATE=`date`
842    THISUSER=`echo $USER`
843    THISVER=
844  MACHINE=`uname -a`  MACHINE=`uname -a`
845  EXECUTABLE=  EXECUTABLE=
846  EXEHOOK=  EXEHOOK=
# Line 488  IEEE= Line 850  IEEE=
850  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
851      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
852  fi  fi
853    FS=
854    FS90=
855    
856  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
857  AD_OPTFILE=  AD_OPTFILE=
# Line 505  TAMC_EXTRA= Line 869  TAMC_EXTRA=
869    
870  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
871  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
872  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
873    
874  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
875  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
876  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
877  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
878  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
879  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
880    
881  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
882  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 541  for i in . $MODS ; do Line 905  for i in . $MODS ; do
905          break          break
906      fi      fi
907  done  done
908  echo -n "  getting local config information:  "  printf "  getting local config information:  "
909  if test -e $gm_local ; then  if test -f $gm_local ; then
910      echo "using $gm_local"      echo "using $gm_local"
911      . $gm_local      . $gm_local
912      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
# Line 551  else Line 915  else
915      echo "none found"      echo "none found"
916  fi  fi
917    
918  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
919  #OPTIONS=  #OPTIONS=
920  #n=0  #n=0
921  #for i ; do  #for i ; do
# Line 563  fi Line 927  fi
927  #done  #done
928  #parse_options  #parse_options
929  ac_prev=  ac_prev=
930  for ac_option ; do  for ac_option in "$@" ; do
931    
932        G2ARGS="$G2ARGS \"$ac_option\""
933    
934      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
935      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 586  for ac_option ; do Line 952  for ac_option ; do
952          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
953              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
954                    
955          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
956              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
957          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
958              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 606  for ac_option ; do Line 972  for ac_option ; do
972          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
973              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
974                    
975            -bash | --bash)
976                ac_prev=BASH ;;
977            -bash=* | --bash=*)
978                BASH=$ac_optarg ;;
979            
980            -makedepend | --makedepend | -md | --md)
981                ac_prev=MAKEDEPEND ;;
982            -makedepend=* | --makedepend=* | -md=* | --md=*)
983                MAKEDEPEND=$ac_optarg ;;
984            
985          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
986              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
987          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
# Line 647  for ac_option ; do Line 1023  for ac_option ; do
1023  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
1024  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
1025  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
1026                        
1027            -cc | --cc)
1028                ac_prev=CC ;;
1029            -cc=* | --cc=*)
1030                CC=$ac_optarg ;;
1031            
1032          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
1033              ac_prev=FC ;;              ac_prev=FC ;;
1034          -fc=* | --fc=*)          -fc=* | --fc=*)
1035              FC=$ac_optarg ;;              FC=$ac_optarg ;;
1036                    
1037            -fs | --fs)
1038                ac_prev=FS ;;
1039            -fs=* | --fs=*)
1040                FS=$ac_optarg ;;
1041            
1042            -fs90 | --fs90)
1043                ac_prev=FS90 ;;
1044            -fs90=* | --fs90=*)
1045                FS90=$ac_optarg ;;
1046            
1047          -ieee | --ieee)          -ieee | --ieee)
1048              IEEE=true ;;              IEEE=true ;;
1049          -noieee | --noieee)          -noieee | --noieee)
1050              IEEE= ;;              IEEE= ;;
1051    
1052            -mpi | --mpi)
1053                MPI=true ;;
1054            -mpi=* | --mpi=*)
1055                MPIPATH=$ac_optarg
1056                MPI=true ;;
1057                    
1058  #       -jam | --jam)  #       -jam | --jam)
1059  #           JAM=1 ;;  #           JAM=1 ;;
# Line 702  if test -f ./.genmakerc ; then Line 1099  if test -f ./.genmakerc ; then
1099      echo      echo
1100  fi  fi
1101    
1102    #  Find the MITgcm ${ROOTDIR}
1103  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1104      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1105        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1106          ROOTDIR=".."          ROOTDIR=".."
1107      else      else
1108          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1109              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1110                  ROOTDIR=$d                  ROOTDIR=$d
1111                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1112                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1113                  break                  break
1114              fi              fi
# Line 727  if test ! -d ${ROOTDIR} ; then Line 1126  if test ! -d ${ROOTDIR} ; then
1126      exit 1      exit 1
1127  fi  fi
1128    
1129    #  Find the MITgcm ${THISVER}
1130    if test -f "${ROOTDIR}/doc/tag-index" ; then
1131        THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`
1132    fi
1133    
1134  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1135  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1136      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 743  if test "x$OPTFILE" != xNONE ; then Line 1147  if test "x$OPTFILE" != xNONE ; then
1147          . "$OPTFILE"          . "$OPTFILE"
1148          RETVAL=$?          RETVAL=$?
1149          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1150              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1151              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1152              exit 1              exit 1
1153          fi          fi
# Line 756  if test "x$OPTFILE" != xNONE ; then Line 1160  if test "x$OPTFILE" != xNONE ; then
1160      fi      fi
1161  fi  fi
1162    
1163    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1164    # check_for_broken_Ff
1165    
1166  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1167  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1168      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 770  if test "x${AD_OPTFILE}" != xNONE ; then Line 1177  if test "x${AD_OPTFILE}" != xNONE ; then
1177          . "$AD_OPTFILE"          . "$AD_OPTFILE"
1178          RETVAL=$?          RETVAL=$?
1179          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1180              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1181              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1182              exit 1              exit 1
1183          fi          fi
# Line 783  if test "x${AD_OPTFILE}" != xNONE ; then Line 1190  if test "x${AD_OPTFILE}" != xNONE ; then
1190      fi      fi
1191  fi  fi
1192    
1193  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1194  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1195    if test ! "x$BASH" = x ; then
1196        # add a trailing space so that it works within the Makefile syntax (see below)
1197        BASH="$BASH "
1198    fi
1199  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1200      cat <<EOF 1>&2      cat <<EOF 1>&2
1201    
# Line 795  Error: no Fortran compiler: please speci Line 1206  Error: no Fortran compiler: please speci
1206  EOF  EOF
1207      exit 1      exit 1
1208  fi  fi
1209    if test "x$CC" = x ; then
1210        CC=cc
1211    #     cat <<EOF 1>&2
1212    # Error: no C compiler: please specify using one of the following:
1213    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1214    #   2) the "-cc=XXX" command-line option
1215    #   3) the "./genmake_local" file
1216    # EOF
1217    #     exit 1
1218    fi
1219  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1220      LINK=$FC      LINK=$FC
1221  fi  fi
 if test "x$CPP" = x ; then  
     CPP="cpp"  
 fi  
1222  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
1223      MAKE="make"      MAKE="make"
1224  fi  fi
1225    if test "x$CPP" = x ; then
1226        CPP=cpp
1227    fi
1228    #EH3 === UGLY ===
1229    #  The following is an ugly little hack to check for $CPP in /lib/ and
1230    #  it should eventually be replaced with a more general function that
1231    #  searches a combo of the user's path and a list of "usual suspects"
1232    #  to find the correct location for binaries such as $CPP.
1233    for i in " " "/lib/" ; do
1234        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1235    done
1236    #EH3 === UGLY ===
1237  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
1238  RETVAL=$?  RETVAL=$?
1239  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 820  EOF Line 1250  EOF
1250  else  else
1251      rm -f test_cpp      rm -f test_cpp
1252  fi  fi
1253  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
     MAKEDEPEND=makedepend  
 fi  
1254  if test "x$LN" = x ; then  if test "x$LN" = x ; then
1255      LN="ln -s"      LN="ln -s"
1256  fi  fi
# Line 840  EOF Line 1268  EOF
1268  fi  fi
1269  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1270    
1271    #  Check for broken *.F/*.f handling and fix if possible
1272    check_for_broken_Ff
1273    
1274    if test ! "x$MPI" = x ; then
1275          echo "  Turning on MPI cpp macros"
1276          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1277    fi
1278    
1279  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1280  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1281  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1282        program hello        program hello
1283        call system('echo hi')        call system('echo hi')
# Line 860  else Line 1295  else
1295  fi  fi
1296  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1297    
1298  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1299  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1300        program hello        program hello
1301        CHARACTER(128) string        CHARACTER(128) string
# Line 881  else Line 1316  else
1316  fi  fi
1317  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1318    
1319  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1320    cat > genmake_tcomp.f <<EOF
1321          program hello
1322          REAL*4 ACTUAL, TARRAY(2)
1323          EXTERNAL ETIME
1324          REAL*4 ETIME
1325          actual = etime( tarray )
1326          print *, tarray
1327          end
1328    EOF
1329    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1330    RETVAL=$?
1331    if test "x$RETVAL" = x0 ; then
1332        HAVE_ETIME=t
1333        DEFINES="$DEFINES -DHAVE_ETIME"
1334        echo "yes"
1335    else
1336        HAVE_ETIME=
1337        echo "no"
1338    fi
1339    rm -f genmake_tcomp*
1340    
1341    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1342  check_HAVE_CLOC  check_HAVE_CLOC
1343  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1344      echo "yes"      echo "yes"
1345  else  else
1346      echo "no"      echo "no"
1347  fi  fi
1348  echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  rm -f genmake_t*
1349  cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
1350  RETVAL=$?  printf "  Can we use stat() through C calls...  "
1351  if test "x$RETVAL" != x0 ; then  check_HAVE_STAT
1352      mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  if test "x$HAVE_STAT" != x ; then
1353        echo "yes"
1354    else
1355        echo "no"
1356  fi  fi
1357  rm -f genmake_t*  rm -f genmake_t*
1358    
1359    printf "  Can we create NetCDF-enabled binaries...  "
1360    check_netcdf_libs
1361    if test "x$HAVE_NETCDF" != x ; then
1362        echo "yes"
1363    else
1364        echo "no"
1365    fi
1366    
1367    
1368  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1369  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1370  for d in $MODS ; do  for d in $MODS ; do
1371      if test ! -d $d ; then      if test ! -d $d ; then
1372          echo          echo
1373          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1374          exit 1          exit 1
1375      else      else
1376          echo -n " $d"          printf " $d"
1377          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1378          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1379      fi      fi
# Line 920  if test "x${PLATFORM}" = x ; then Line 1388  if test "x${PLATFORM}" = x ; then
1388  fi  fi
1389    
1390  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1391      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1392        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1393          EXEDIR=../exe          EXEDIR=../exe
1394      else      else
1395          EXEDIR=.          EXEDIR=.
# Line 935  if test "x${TOOLSDIR}" = x ; then Line 1404  if test "x${TOOLSDIR}" = x ; then
1404      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1405  fi  fi
1406  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1407      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1408      exit 1      exit 1
1409  fi  fi
1410  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1411      S64='$(TOOLSDIR)/set64bitConst.sh'      echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1412        RETVAL=$?
1413        if test "x${RETVAL}" = x0 ; then
1414            S64='$(TOOLSDIR)/set64bitConst.sh'
1415        else
1416            echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1417            RETVAL=$?
1418            if test "x${RETVAL}" = x0 ; then
1419                S64='$(TOOLSDIR)/set64bitConst.csh'
1420            else
1421                cat <<EOF
1422    
1423    ERROR: neither of the two default scripts:
1424    
1425        ${TOOLSDIR}/set64bitConst.sh
1426        ${TOOLSDIR}/set64bitConst.csh
1427    
1428      are working so please check paths or specify (with \$S64) a
1429      working version of this script.
1430    
1431    EOF
1432                exit 1
1433            fi
1434        fi
1435  fi  fi
1436  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1437    
# Line 956  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1448  if test -r $ROOTDIR"/eesupp/src/Makefile
1448          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1449      else      else
1450          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1451          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1452          exit 1          exit 1
1453      fi      fi
1454  fi  fi
1455    
1456    #same for exch2
1457    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1458        echo "  Making source files in exch2 from  templates"
1459        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1460        RETVAL=$?
1461        if test "x${RETVAL}" = x0 ; then
1462            rm -f make_exch2.errors
1463        else
1464            echo "Error: problem encountered while building source files in exch2:"
1465            cat make_exch2.errors 1>&2
1466            exit 1
1467        fi
1468    fi
1469    
1470  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1471  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1472      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 1016  else Line 1522  else
1522          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1523          RETVAL=$?          RETVAL=$?
1524          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1525              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1526              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1527              exit 1              exit 1
1528          fi          fi
# Line 1024  else Line 1530  else
1530              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1531          done          done
1532          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1533          expand_pkg_groups          RET=1
1534            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1535          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1536      fi      fi
1537  fi  fi
1538    
1539  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1540    for i in $PACKAGES ; do
1541        echo $i >> ./.tmp_pack
1542    done
1543    for i in `grep  "-" ./.tmp_pack` ; do
1544        j=`echo $i | sed 's/[-]//'`
1545        DISABLE="$DISABLE $j"
1546    done
1547  pack=  pack=
1548  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1549      addit="t"      addit="t"
# Line 1046  PACKAGES="$pack" Line 1560  PACKAGES="$pack"
1560  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1561  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1562  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1563    # Test if each explicitly referenced package exists
1564  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1565      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1566        if test ! -d "$ROOTDIR/pkg/$j" ; then
1567          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1568          exit 1          exit 1
1569      fi      fi
1570      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1571  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1572  PACKAGES=  PACKAGES=
1573  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1574      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1575  done  done
1576    rm -f ./.tmp_pack
1577  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1578    
1579    #  Check availability of NetCDF and then either build the MNC template
1580    #  files or delete mnc from the list of available packages.
1581    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1582    RETVAL=$?
1583    if test "x$RETVAL" = x0 ; then
1584        if test "x$HAVE_NETCDF" != xt ; then
1585            cat <<EOF
1586    
1587    *********************************************************************
1588    WARNING: the "mnc" package was enabled but tests failed to compile
1589      NetCDF applications.  Please check that:
1590    
1591      1) NetCDF is correctly installed for this compiler and
1592      2) the LIBS variable (within the "optfile") specifies the correct
1593           NetCDF library to link against.
1594    
1595      Due to this failure, the "mnc" package is now DISABLED.
1596    *********************************************************************
1597    
1598    EOF
1599            PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1600            DISABLE="$DISABLE mnc"
1601        else
1602            ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1603            RETVAL=$?
1604            if test "x${RETVAL}" = x0 ; then
1605                rm -f make_mnc.errors
1606            else
1607                echo "Error: problem encountered while building source files in pkg/mnc:"
1608                cat make_mnc.errors 1>&2
1609                exit 1
1610            fi
1611        fi
1612    fi
1613    
1614  echo "  applying package dependency rules"  echo "  applying package dependency rules"
1615  ck=  ck=
1616  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
# Line 1125  while test "x$ck" != xtt ; do Line 1675  while test "x$ck" != xtt ; do
1675              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1676              exit 1              exit 1
1677          fi          fi
1678          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1679            #i=$(( $i + 1 ))
1680      done      done
1681      ck=$ck"t"      ck=$ck"t"
1682  done  done
# Line 1144  for i in $PACKAGES ; do Line 1695  for i in $PACKAGES ; do
1695      fi      fi
1696  done  done
1697    
   
1698  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1699  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
1700  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 1178  for i in $PACKAGES ; do Line 1728  for i in $PACKAGES ; do
1728  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1729      case $i in      case $i in
1730          aim_v23)          aim_v23)
             DEFINES="$DEFINES -DALLOW_AIM"  
1731              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1732              echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
1733              ;;              ;;
1734      esac      esac
1735  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
# Line 1189  done Line 1738  done
1738    
1739  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1740  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1741  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1742      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1743  fi  fi
1744  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1745      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1746      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1747          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1748          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1749          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1750      else              exit 1
1751          SOURCEDIRS="$SOURCEDIRS $adr"          else
1752      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1753      adr="$ROOTDIR/$d/inc"          fi
1754      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1755          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1756          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1757          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1758      else              exit 1
1759          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1760      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1761  done          fi
1762        done
1763    fi
1764    
1765  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1766  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1767  CPP_OPTIONS=  CPP_OPTIONS=
1768    CPP_EEOPTIONS=
1769  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1770    names=`ls -1 "$ROOTDIR/pkg"`
1771  for i in $spaths ; do  for i in $spaths ; do
1772      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1773      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1774          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1775          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1776          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1777            for n in $names ; do
1778                test_for_package_in_cpp_options $CPP_OPTIONS $n
1779            done
1780        fi
1781        try="$i/CPP_EEOPTIONS.h"
1782        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1783            echo "    found CPP_EEOPTIONS=\"$try\""
1784            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1785    #**** not yet enabled ****
1786    #        test_for_mpi_in_cpp_eeoptions $try
1787    #**** not yet enabled ****
1788            CPP_EEOPTIONS="$try"
1789      fi      fi
1790  done  done
1791  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1792      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1793      exit 1      exit 1
1794  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1795    
1796  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1797  #  compiler.  #  compiler.
# Line 1248  for i in $SOURCEDIRS ; do Line 1806  for i in $SOURCEDIRS ; do
1806      done      done
1807  done  done
1808    
1809    
1810  echo  echo
1811  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1812  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1813  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1814      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
1815          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1816      fi      fi
1817  done  done
# Line 1264  rm -rf .links.tmp Line 1821  rm -rf .links.tmp
1821  mkdir .links.tmp  mkdir .links.tmp
1822  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1823  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1824  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1825  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1826  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1827  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1828  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1829  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1830  for d in $alldirs ; do  for d in $alldirs ; do
1831      deplist=      deplist=
# Line 1284  for d in $alldirs ; do Line 1841  for d in $alldirs ; do
1841                          ;;                          ;;
1842                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
1843                          ;;                          ;;
1844                      ./BUILD_INFO.h)
1845                            ;;
1846                    *)                    *)
1847                          touch .links.tmp/$sf                          touch .links.tmp/$sf
1848                          deplist="$deplist $sf"                          deplist="$deplist $sf"
# Line 1293  for d in $alldirs ; do Line 1852  for d in $alldirs ; do
1852                  case $extn in                  case $extn in
1853                      F)                      F)
1854                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1855                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1856                          ;;                          ;;
1857                      F90)                      F90)
1858                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1859                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1860                          ;;                          ;;
1861                      c)                      c)
1862                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1863                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1864                          ;;                          ;;
1865                      h)                      h)
1866                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1867                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1868                          ;;                          ;;
1869                      flow)                      flow)
1870                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1871                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1872                          ;;                          ;;
1873                  esac                  esac
1874              fi              fi
# Line 1329  echo "" >> f90srclist.inc Line 1888  echo "" >> f90srclist.inc
1888  echo "" >> hlist.inc  echo "" >> hlist.inc
1889  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
1890    
1891  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1892      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1893  fi  fi
1894  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1338  echo "#    $MACHINE" >> $MAKEFILE Line 1897  echo "#    $MACHINE" >> $MAKEFILE
1897  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1898  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1899  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1900  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1901  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1902  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
1903    
1904  EXE_AD=$EXECUTABLE"_ad"  EXE_AD=$EXECUTABLE"_ad"
1905  EXE_FTL=$EXECUTABLE"_ftl"  EXE_FTL=$EXECUTABLE"_ftl"
1906  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1907    
1908  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1909    #
1910    # OPTFILE="$OPTFILE"
1911  #  #
1912  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1913  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1383  EXE_SVD     = ${EXE_SVD} Line 1944  EXE_SVD     = ${EXE_SVD}
1944  ENABLED_PACKAGES = ${ENABLED_PACKAGES}  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1945  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1946    
1947    # These files are created by Makefile
1948    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
1949    
1950  EOF  EOF
1951    
1952  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1400  KPP = ${KPP} Line 1964  KPP = ${KPP}
1964  FC = ${FC}  FC = ${FC}
1965  # Fortran compiler  # Fortran compiler
1966  F90C = ${F90C}  F90C = ${F90C}
1967    # C compiler
1968    CC = ${CC}
1969  # Link editor  # Link editor
1970  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1971    
1972  # Defines for CPP  # Defines for CPP
1973  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1422  CFLAGS = ${CFLAGS} Line 1988  CFLAGS = ${CFLAGS}
1988  NOOPTFILES = ${NOOPTFILES}  NOOPTFILES = ${NOOPTFILES}
1989  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
1990  # Flags and libraries needed for linking  # Flags and libraries needed for linking
1991  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS}
1992  # Name of the Mekfile  # Name of the Mekfile
1993  MAKEFILE=${MAKEFILE}  MAKEFILE=${MAKEFILE}
1994    
# Line 1433  cat csrclist.inc      >> $MAKEFILE Line 1999  cat csrclist.inc      >> $MAKEFILE
1999  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
2000  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
2001  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2002  echo               >> $MAKEFILE  echo >> $MAKEFILE
2003  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2004  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
2005  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2006    echo >> $MAKEFILE
2007    echo '.SUFFIXES:' >> $MAKEFILE
2008    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
2009  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
2010  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
2011    
2012  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2013    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
2014  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2015  \$(EXECUTABLE): links \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
2016          @echo Creating \$@ ...          @echo Creating \$@ ...
2017          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2018  depend:  depend:
2019          @make links          @make links
2020          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
2021          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2022            -rm -f makedepend.out
2023    
2024  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) ${PACKAGES_DOT_H} AD_CONFIG.h  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2025    
2026  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
2027    
# Line 1464  output.txt: \$(EXECUTABLE) Line 2030  output.txt: \$(EXECUTABLE)
2030          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2031    
2032  clean:  clean:
2033          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2034  Clean:  Clean:
2035          @make clean          @make clean
2036          @make cleanlinks          @make cleanlinks
2037          -rm -f ${PACKAGES_DOT_H} AD_CONFIG.h          -rm -f \$(SPECIAL_FILES)
2038          -rm -f Makefile.bak genmake_state genmake_*optfile genmake_warnings make.log          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2039  CLEAN:  CLEAN:
2040          @make Clean          @make Clean
2041          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2042          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2043          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2044          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
2045    
2046  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2047  makefile:  makefile:
2048          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
2049  cleanlinks:  cleanlinks:
2050          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2051    
2052  # Special targets  # Special targets (SPECIAL_FILES) which are create by make
2053  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
2054          @echo Creating \$@ ...          @echo Creating \$@ ...
2055          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2056  AD_CONFIG.h:  AD_CONFIG.h:
2057          @echo Creating \$@ ...          @echo Creating \$@ ...
2058          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2059    FC_NAMEMANGLE.h:
2060            @echo Creating \$@ ...
2061            echo "$FC_NAMEMANGLE" > \$@
2062    
2063    BUILD_INFO.h:
2064            @echo Creating \$@ ...
2065    EOF
2066    
2067  # The normal chain of rules is (  .F - .f - .o  )  test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
2068  .F.f:  test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2069    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2070    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2071    
2072    cat >>$MAKEFILE <<EOF
2073    
2074    # The normal chain of rules is (  .F - .$FS - .o  )
2075    
2076    ## This nullifies any default implicit rules concerning these two file types:
2077    ## %.o : %.F
2078    
2079    .F.$FS:
2080          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2081  .f.o:  .$FS.o:
2082          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2083  .F90.f90:  .F90.$FS90:
2084          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2085  .f90.o:  .$FS90.o:
2086          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2087  .c.o:  .c.o:
2088          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
2089    
2090  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2091  .F.p:  .F.p:
2092          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2093  .p.f:  .p.$FS:
2094          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2095    
2096  #=========================================  #=========================================
# Line 1533  done Line 2117  done
2117    
2118  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
2119  echo >> $MAKEFILE  echo >> $MAKEFILE
2120  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2121  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
2122  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2123      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2124      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2125  done  done
2126  echo >> $MAKEFILE  echo >> $MAKEFILE
2127  rm -f ad_files  rm -f ad_files
# Line 1549  adall: ad_taf Line 2133  adall: ad_taf
2133  adtaf: ad_taf_output.f  adtaf: ad_taf_output.f
2134  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
2135    
2136  ad_input_code.f: links \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2137          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2138          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2139          -rm -f ad_config.template          -rm -f ad_config.template
2140          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1575  ad_tamc_output.f: ad_input_code.f Line 2159  ad_tamc_output.f: ad_input_code.f
2159  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2160          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2161    
2162    adonlyfwd:
2163            patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2164    
2165    adtrick:
2166            patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2167    
2168  # ... FTL ...  # ... FTL ...
2169  ftlall: ftl_taf  ftlall: ftl_taf
2170  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.f
2171  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
2172    
2173  ftl_input_code.f: links \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2174          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2175          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2176          -rm -f ftl_config.template          -rm -f ftl_config.template
2177          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1610  ftl_tamc: ftl_tamc_output.o \$(OBJFILES) Line 2199  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2199    
2200  # ... SVD ...  # ... SVD ...
2201  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.f ftl_taf_output.f
2202  svdall: svd_taf          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2203            @echo "--->>> Do make svdall afterwards to compile. <<<---"
2204    svdall: svd_touch svd_taf
2205    
2206  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)  svd_taf: \$(OBJFILES)
2207          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2208    
2209            @echo "--->>> Only COMPILE svd code! <<<---"
2210            @echo "--->>> Assumes you previously <<<---"
2211            @echo "--->>> did make svdtaf        <<<---"
2212    
2213    svd_touch:
2214            @echo "--->>> Only COMPILE svd code! <<<---"
2215            @echo "--->>> Assumes you previously <<<---"
2216            @echo "--->>> did make svdtaf        <<<---"
2217            touch ad_taf_output.f ftl_taf_output.f
2218            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.f
2219            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.f
2220            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2221            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2222            -rm -f ftl_config.template
2223    
2224  #=========================================  #=========================================
2225    
# Line 1631  for i in $KPPFILES ; do Line 2236  for i in $KPPFILES ; do
2236      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2237          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2238      fi      fi
2239      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2240  done  done
2241    
2242  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1641  for i in $NOOPTFILES ; do Line 2246  for i in $NOOPTFILES ; do
2246      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2247          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2248      fi      fi
2249      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2250      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2251  done  done
2252    
# Line 1655  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2260  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2260  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2261    
2262  # Create special header files  # Create special header files
2263  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2264  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
2265      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2266  else  else
2267      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2268      RETVAL=$?      RETVAL=$?
2269      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
2270          rm -f $PACKAGES_DOT_H".tmp"          rm -f $PACKAGES_DOT_H".tmp"
# Line 1669  else Line 2274  else
2274      fi      fi
2275  fi  fi
2276  if test ! -f AD_CONFIG.h ; then  if test ! -f AD_CONFIG.h ; then
2277      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2278  fi  fi
2279    
2280    
2281  #  Write the "state" for future records  #  Write the "state" for future records
2282  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2283      echo -n "" > genmake_state      printf "" > genmake_state
2284      for i in $gm_state ; do      for i in $gm_state ; do
2285          t1="t2=\$$i"          t1="t2=\$$i"
2286          eval $t1          eval $t1

Legend:
Removed from v.1.47  
changed lines
  Added in v.1.112

  ViewVC Help
Powered by ViewVC 1.1.22